#pragma once

#include "CoreMinimal.h"
#include "BasicChargeableInteraction.h"
#include "GameplayTagContainer.h"
#include "SendToCageInteraction.generated.h"

class ASurvivor;
class ADBDPlayer;

UCLASS(Blueprintable, Abstract, EditInlineNew, meta=(BlueprintSpawnableComponent))
class DBDGAMEPLAY_API USendToCageInteraction : public UBasicChargeableInteraction
{
	GENERATED_BODY()

protected:
	UPROPERTY(EditAnywhere)
	FGameplayTag _sendToCageScoreEvent;

protected:
	UFUNCTION(BlueprintPure)
	ASurvivor* GetOwningSurvivor() const;

public:
	UFUNCTION(BlueprintCallable, BlueprintImplementableEvent, BlueprintCosmetic)
	void FX_InteractionStart();

	UFUNCTION(BlueprintCallable, BlueprintImplementableEvent, BlueprintCosmetic)
	void FX_InteractionChargeCompleted(ADBDPlayer* player);

	UFUNCTION(BlueprintCallable, BlueprintImplementableEvent, BlueprintCosmetic)
	void FX_InteractionCancel();

public:
	USendToCageInteraction();
};

FORCEINLINE uint32 GetTypeHash(const USendToCageInteraction) { return 0; }
